"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConsoleGroupAsync = exports.ConsoleGroup = void 0;
const tslib_1 = require("tslib");
function ConsoleGroup(enterMessage, leaveMessage) {
    return function (target, propertyKey, descriptor) {
        const oldFunction = target[propertyKey];
        descriptor.value = function (...args) {
            console.group(enterMessage ? enterMessage(...args) : `starting ${propertyKey}`);
            try {
                return oldFunction.bind(this)(...args);
            }
            finally {
                console.log(leaveMessage ? leaveMessage(...args) : `ending ${propertyKey}`);
                console.groupEnd();
            }
        };
    };
}
exports.ConsoleGroup = ConsoleGroup;
function ConsoleGroupAsync(enterMessage, leaveMessage) {
    return function (target, propertyKey, descriptor) {
        const oldFunction = target[propertyKey];
        descriptor.value = function (...args) {
            return tslib_1.__awaiter(this, void 0, void 0, function* () {
                console.group(enterMessage ? enterMessage(...args) : `starting ${propertyKey}`);
                try {
                    return yield oldFunction.bind(this)(...args);
                }
                finally {
                    console.log(leaveMessage ? leaveMessage(...args) : `ending ${propertyKey}`);
                    console.groupEnd();
                }
            });
        };
    };
}
exports.ConsoleGroupAsync = ConsoleGroupAsync;
//# sourceMappingURL=console-group.decorator.js.map