"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OnChange = void 0;
function OnChange(predicate) {
    return (target, propertyName, descriptor = Object.getOwnPropertyDescriptor(target, propertyName)) => {
        if (!descriptor) {
            descriptor = {
                set: function (value) {
                    this[`$OnChange.${propertyName}`] = value;
                },
                get: function () {
                    return this[`$OnChange.${propertyName}`];
                },
                configurable: true
            };
            Object.defineProperty(target, propertyName, descriptor);
        }
        const getFunc = descriptor.get;
        const setFunc = descriptor.set;
        Object.defineProperty(target, propertyName, {
            get: function () {
                return getFunc === null || getFunc === void 0 ? void 0 : getFunc.call(this);
            },
            set: function (v) {
                setFunc === null || setFunc === void 0 ? void 0 : setFunc.call(this, v);
                predicate(this);
            },
            configurable: true
        });
    };
}
exports.OnChange = OnChange;
//# sourceMappingURL=on-change.decorator.js.map