"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generatePassword = void 0;
const random_1 = require("./random");
function generatePassword(minLength = 8, maxLength = 12) {
    const digits = '1234567890';
    const symbols = '_!#$';
    const upperCase = 'ABCDEFGHKL';
    const lowerCase = 'mnpqrstuvwxyz';
    const password = [];
    const all = `${digits}${symbols}${upperCase}${lowerCase}`;
    for (let i = 0; i < random_1.random(minLength, maxLength, true); i++) {
        const symbolIndex = random_1.random(0, all.length - 1, true);
        password.splice(0, 0, all[symbolIndex]);
    }
    if (!password.some(d => digits.includes(d))) {
        const insertIndex = random_1.random(0, password.length - 1, true);
        const symbolIndex = random_1.random(0, digits.length - 1, true);
        password.splice(insertIndex, 0, digits[symbolIndex]);
    }
    if (!password.some(d => symbols.includes(d))) {
        const insertIndex = random_1.random(0, password.length - 1, true);
        const symbolIndex = random_1.random(0, symbols.length - 1, true);
        password.splice(insertIndex, 0, symbols[symbolIndex]);
    }
    if (!password.some(d => upperCase.includes(d))) {
        const insertIndex = random_1.random(0, password.length - 1, true);
        const symbolIndex = random_1.random(0, upperCase.length - 1, true);
        password.splice(insertIndex, 0, upperCase[symbolIndex]);
    }
    if (!password.some(d => lowerCase.includes(d))) {
        const insertIndex = random_1.random(0, password.length - 1, true);
        const symbolIndex = random_1.random(0, lowerCase.length - 1, true);
        password.splice(insertIndex, 0, lowerCase[symbolIndex]);
    }
    return password.join('');
}
exports.generatePassword = generatePassword;
//# sourceMappingURL=passgen.js.map