"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.schedule = void 0;
const tslib_1 = require("tslib");
function schedule(process, callback = () => { }, timeout = 3000) {
    let timer = null;
    let cancel = false;
    const promise = new Promise((resolve, reject) => tslib_1.__awaiter(this, void 0, void 0, function* () {
        let done = false;
        timer = setTimeout(() => {
            if (done && !cancel) {
                resolve();
                callback();
            }
            timer = null;
        }, timeout);
        yield process();
        done = true;
        if (timer == null && !cancel) {
            resolve();
            callback();
        }
    }));
    return {
        awaiter: promise,
        cancel: () => { cancel = true; }
    };
}
exports.schedule = schedule;
//# sourceMappingURL=scheduler.js.map